var fs = require('fs');
var _ = require('lodash');
var cl = require('console');
var book = require('topsin.excelxs');

var fileData = jsonRead();  //读取配置文件

var fileCollectionPath = fileData['fileCollectionPath'];  //文件收集地址
var fileSavePath = fileCollectionPath + 'fileStore/'; 
var haveReadPath = fileSavePath + 'haveRead/';
var unReadPath = fileSavePath + 'unRead/';

var db = require('topsin.database');  //数据库连接
db.addConnection({
    database_type:'pg',
    database_host:'139.196.104.13:5433',
    database_name:'PMO_TRAINING',
    database_user:'toplinker',
    database_pwd:'TopLinker0510'
}, "MES_DB");

var query = db.query('MES_DB');  //获取数据库操作对象

var runfile = fileData['runnFile'];  
var result = fs.fileExists(runfile);  //文件执行状态

if(result){
    cl.log('脚本正在运行,请稍后再试');
}else{
    checkFilePath();  //需求目录检测

    var file = fs.openFile(runfile, 'w');  //程序开始时生成执行状态文件
    file.write('running');
    file.close();

    var fileListInfo = fs.listDir(fileCollectionPath, 1);  //获取目录下文件信息
    var excelList = arrExcel(fileListInfo);  //获取目录下所有excel文件列表

    var haveReadInfo = fs.listDir(haveReadPath, 1);  //获取已读目录下文件信息
    var haveReadList = arrExcel(haveReadInfo);

    var res1 = excelList.map(function(item){
        return 'confirmation' + item.split('confirmation')[1];
    });
    var res2 = haveReadList.map(function(item){
        return 'confirmation' + item.split('confirmation')[1];
    });

    var unReadMoveList = _.difference(res1, res2)  //获取目录下未被读取到过的excel文件

    unReadMoveList.forEach(function(item){  //复制未读excel文件到未读目录下
        var iSrc = fileCollectionPath + item;
        var iDest = unReadPath + item;
        fs.copyFile(iSrc, iDest ,true);
    });

    var unReadInfo = fs.listDir(unReadPath, 1);  //获取未读目录下文件信息
    var unReadList = arrExcel(unReadInfo);

    if(unReadList.length == 0){
        cl.log('暂无待导入的excel文件...');
    }else{
        for(var i=0; i<unReadList.length; i++){
            cl.log('正在导入文件' + unReadList[i]);

            var nowfileData = jsonRead();  //重新获取配置文件
            var tableData = getRangeTable(unReadList[i], nowfileData);  //获取excel文件数据
            var iData = getFormatData(tableData);   //excel表数据入库格式拼接
            var newfileData = jsonRead();  //获取最新的配置文件信息
            var newfieldMatch = newfileData['fieldMatch'];
            var newfieldKeys = _.keys(newfieldMatch);  //获取最新的表字段
            var dbData = getDbData(newfieldKeys);  //获取当前数据库对应写入字段的所有数据
            var flag = dataInsert(iData, dbData, newfieldKeys);

            if(flag == 0){  //说明上述操作都执行成功，移动该文件至已读文件夹
                var movePath = haveReadPath + 'confirmation' + unReadList[i].split('confirmation')[1];
                fs.rename(unReadList[i], movePath);
                cl.log('文件' + unReadList[i] + '导入完毕');
            };
        };
    };

    fs.unlink(runfile);  //程序运行结束删除执行状态文件
};

function checkFilePath(){  //自定义目录检测
    if(fs.dirExists(fileSavePath) == false){
        fs.mkdir(fileSavePath);
    };
    if(fs.dirExists(haveReadPath) == false){
        fs.mkdir(haveReadPath);
    };
    if(fs.dirExists(unReadPath) == false){
        fs.mkdir(unReadPath);
    };
};

function jsonRead(){  //读取json文件
    try {
        var file = fs.openFile('excelConfig.json');
        var data = JSON.parse(file.readAll());
        return data;  
    } catch (error) {
        cl.log(error);
    };
};

function jsonWrite(data){  //写入json文件
    var loadData = JSON.stringify(data);
    var file = fs.openFile('excelConfig.json', 'w');
    file.write(loadData);
    file.close();
};

function arrExcel(fileList){  //提取excel路径
    var list = [];
    _.filter(fileList, function(o){
        if(o['baseName'].indexOf('confirmation') > -1 ){
            list.push(_.at(o, 'path')[0]);
        }
    });
    return list;
};

function getRangeTable(path, fileData){  //获取excel表的数据
    try {
        book.open(path);

        var tableData = [];
        var sheet = book.getActiveSheet();  //获取当前表
        var countCol = sheet.getLastCol();  //当前表总列数
        var countRow = sheet.getLastRow();  //当前表总行数
        var firstRow = [];  //提取第一行数据

        for(var k=0; k<countCol; k++){
            firstRow.push(sheet.getCellValue(0, k));
        };

        var fieldMatch = fileData['fieldMatch'];  //读取字段匹配信息
        var filedValues = _.values(fieldMatch);
        var newRowlList1 = _.difference(firstRow, filedValues);  //与固定字段作对比

        if(newRowlList1.length != 0){
            var attrDataValues = _.values(fieldMatch['attr_data']);
            var newRowlList2 = _.difference(newRowlList1, attrDataValues);  //与之前的新增字段作对比
            if(newRowlList2.length != 0){  //存在新增字段
                cl.log('新增列名为：',newRowlList2);
                var parseFielList = newRowlList2.map(function(item){  // 解析新增列名为合适的字段名
                    return colParse(item);
                });

                parseFielList.forEach(function(item, index){  //将新增字段名和对应的列名存入配置文件
                    fieldMatch['attr_data'][item] = newRowlList2[index];
                });
                cl.log('新增字段为：',parseFielList);
                jsonWrite(fileData);  //将更新的字段信息写入配置文件
            };
        };

        var postDateIndex = 0;
        var entryTimeIndex = 0;
        firstRow.forEach(function(item, index){  //判断生成时间 和 确认时间的列的索引位置
            //模糊匹配不严谨
            if(item.search('Posting Date') != -1 || item.search('生产时间') != -1){
                postDateIndex = index;
            };
            if(item.search('Confirmation Entry Time') != -1 || item.search('确认时间') != -1){
                entryTimeIndex = index;
            };
        });

        //表数据写入数组
        for(var i=0; i<countRow; i++){
            var arry = [];

            for(var j=0; j<countCol; j++){  //如果列被改变，那么要考虑需要转变时间格式的两列还是不是日期格式的那两列
                if(i != 0 && j == postDateIndex){
                    arry.push(formatDate(sheet.getCellValue(i, j), '-'));
                }else if(i != 0 && j == entryTimeIndex){
                    arry.push(formatTime(sheet.getCellValue(i, j), ':'));
                }else{
                    arry.push(sheet.getCellValue(i, j));
                };
            };
            tableData.push(arry);
        };

        book.close();

        return tableData;
    } catch (error) {
        cl.log(error);
    };
};

function colParse(colName){  //列名解析成合适的字段名(根据之前的列名来判断)
    var str = '';
    if(colName.indexOf('\n') != -1){
        str = colName.trim().split('\n')[0];
    }else{
        str = colName;  //没有 \n 就默认 没有中文
    };

    str = str.trim().toLowerCase();
    strArr = str.split(' ');

    var arr = [];
    strArr.forEach(function(item){
        if(item != '' && item[0] != '(' && item[-1] != ')'){
            arr.push(item.trim());
        };
    });

    str = arr.join('_');
    str = str.split('.').join('_');

    return str;
};

function formatDate(numb, format) {  //对年月日进行格式化处理
    if (numb != undefined) {
        var time = new Date((numb - 1) * 24 * 3600000 + 1);
        time.setYear(time.getFullYear() - 70);
        var year = time.getFullYear() + '';
        var month = time.getMonth() + 1 + '';
        var date = time.getDate() + '';
        if (format && format.length === 1) {
            return year + format + (month < 10 ? '0' + month : month) + format + (date < 10 ? '0' + date : date);
        };
        return year + (month < 10 ? '0' + month : month) + (date < 10 ? '0' + date : date);
    } else {
        return undefined;
    };
};

function formatTime(numb, format) {  //对时分秒进行格式化处理
    var hourTmp = numb * 24;
    var hour = Math.floor(hourTmp);
    var minuteTmp = hourTmp - hour;
    var minute = Math.floor(minuteTmp * 60);
    var secondTmp = (minuteTmp * 60) - minute;
    var second = Math.round(secondTmp * 60);
    if(second == 60){
        second = 0;
        minute = minute + 1;
    };
    if(minute == 60){
        minute = 0;
        hour = hour + 1;
    };
    return (hour < 10 ? '0' + hour : hour) + format + (minute < 10 ? '0' + minute : minute) + format + (second < 10 ? '0' + second : second);
};

function getFormatData(tableData){
    var batchData = [];
    var colNameList = tableData[0];  //获取excel第一行列名
    var fileData = jsonRead();  //获取最新的配置文件信息
    var fieldMatch = fileData['fieldMatch'];
    var fieldKeys = _.keys(fieldMatch);
    var fieldValues = _.values(fieldMatch);
    var attrDataKeys = _.keys(fieldMatch['attr_data']);  //获取新增字段的键值
    var attrDataValues = _.values(fieldMatch['attr_data']);
    var importData = _.drop(tableData);  //删除第一行列名

    importData.forEach(function(item1){  //处理批量插入的数据格式
        var obj = {};
        item1.forEach(function(item2, index2){  //获取字段对应列名的实际索引来得到字段的value值
            if(fieldKeys[index2] == 'attr_data'){  //获取新增字段对应的数据
                //待测试：如果没有新增字段，是插入的数据是没有attr_data的，因为索引长度不够
                var jsonObj = {};
                attrDataKeys.forEach(function(item3, index3){
                    jsonObj[item3] = item1[colNameList.indexOf(attrDataValues[index3])];
                });
                obj[fieldKeys[index2]] = jsonObj;  //先不转成joson，因为后面要进行更新对比
            }else{
                obj[fieldKeys[index2]] = item1[colNameList.indexOf(fieldValues[index2])];
            };
        });
        batchData.push(obj);
    });

    return batchData;
};

function getDbData(fieldList){
    query.begin();  //事务
    try {
        var data = query.selectArrayMap({
            table:'sec_production_order_confirmation_1',
            field: fieldList,
            field_format:{"tags":'array', attr_data:'json'}
        });
        // if (query.lastError().isValid()){  //此处lastError报错
        //     throw query.lastError().text();
        // }
        query.commit();
    } 
    catch (error) {
        query.rollback();
    };

    return data;
};

function dataInsert(iData, dbData, fieldList){
    var flag = 0;
    var primaryField = ['confirmation', 'plant', 'material', 'posting_date', 'confirmation_entry_time', 'activity']
    var otherField = _.difference(fieldList, primaryField);

    cl.log('当前数据库表中已存在数据:' + dbData.length + '条');

    if(dbData.length == 0){  //首次批量插入数据
        batchInsert(iData, fieldList);
        cl.log('本次导入共插入数据：' + iData.length + '条')
    }else{
        var batchInsertData = [];  //待批量插入的数据
        var updateData = [];  //待更新的数据
        var arrPrimary = []; 

        dbData.forEach(function(item){   //主键对应值拼接(用于比对插入数据是否重复)
            arrPrimary.push(getValueSplice(item, primaryField));
        });

        iData.forEach(function(item){
            var itemPrimarySplice = getValueSplice(item, primaryField);  //待插入数据的主键值拼接
            var dbIndex = arrPrimary.indexOf(itemPrimarySplice);

            if(dbIndex > -1){
                var updateObj = checkUpdate(item, dbData[dbIndex], otherField);  //检查是否存在更新数据

                if(Object.keys(updateObj).length > 0){ //说明存在更新数据
                    var updateInfo = {};
                    updateInfo['iData'] = updateObj;
                    updateInfo['iWhere'] = getPrimaryData(item, primaryField);
                    updateData.push(updateInfo);
                };
            }else{
                batchInsertData.push(item);  //不是重复数据就直接插入
            };
        });

        if(updateData.length != 0){
            updateData.forEach(function(item){
                updateRow(item);
            });
            cl.log('本次导入共更新数据:' + updateData.length + '条');
            // cl.log('更新数据如下：');
            // updateData.forEach(function(item){
            //     cl.log(item);
            // });
        }else{  
            cl.log('本次导入没有更新数据');
        };

        if(batchInsertData.length != 0){
            batchInsert(batchInsertData, fieldList);
            cl.log('本次共导入新增数据:' + batchInsertData.length + '条');
            // cl.log('插入数据如下：');
            // batchInsertData.forEach(function(item){
            //     cl.log(item);
            // });
        }else{
            cl.log('本次导入没有新增数据');
        };
    };

    return flag;
};

function batchInsert(data, fieldList){  //批量插入数据
    var iData = [];
    data.forEach(function(item){  //attr_data字段值要转成json字符串
        if('attr_data' in item){
            jsonStr = JSON.stringify(item['attr_data']);
            item['attr_data'] = jsonStr
            iData.push(item);
        }else{
            iData.push(item);
        };
    });
    // iData.forEach(function(item){
    //     cl.log(item)
    // });

    query.begin();  //事务
    try {
        query.batchInsert(
            'sec_production_order_confirmation_1',
            fieldList,
            iData
        );
        // if (query.lastError().isValid()){  //此处lastError报错
        //     throw query.lastError().text();
        // }
        query.commit();
    } 
    catch (error) {
        cl.log('批量插入数据报错：' + error);
        query.rollback();
    };
};

function getValueSplice(obj, primaryField){  //主键字段值拼接
    var str = '';

    primaryField.forEach(function(item){
        str += obj[item];
    });

    return str;
};

function checkUpdate(insertData, dbData, otherField){  //检查是否需要更新
    var obj = {};

    otherField.forEach(function(item){
        if(item == 'attr_data'){
            var equal = _.isEqual(insertData[item], dbData[item]);
            if(equal == false){
                obj[item] = insertData[item];
            };
        }else{
            if(insertData[item] != dbData[item]){
                obj[item] = insertData[item];
            };
        };
    });

    return obj;
};

function getPrimaryData(data ,primaryField){  //获取主键数据对象，用于更新数据时找到要更新的记录
    var obj = {};
    primaryField.forEach(function(item){
        obj[item] = data[item]; 
    });
    return obj;
};

function updateRow(updateData){  //更新数据
    iData = updateData['iData'];
    iWhere = updateData['iWhere'];
    query.begin();  //事务

    try {
        query.updateRow({
            table:'sec_production_order_confirmation_1',
            data: iData,
            where:iWhere,
            update_policy:{tags:'array_append', attr_data:'json_merge'}
        });
        //此处lastError报错
        // if (query.lastError().isValid()){
        //     throw query.lastError().text();
        // }
        query.commit();
    } 
    catch (error) {
        cl.log('更新数据报错：' + error);
        query.rollback();
    };
};

db.removeConnection('MES_DB');  //移除数据库连接

// 待扩展
// 1、插入字段的数据类型约束
// 2、日志文件
// 3、邮件告警

//注意事项
// 1、新增列名不能为空，否则新增字段会为显示为空并更新数据库
// 2、新增列名不能重名，否则会与之前的列名数据冲突
// 3、若手动修改配置文件中的新增字段名，则会在数据库中新增该字段信息，
//    且其数据取该字段对应的列名的数据,若被修改的字段与其对应的列名在分别在数据库中都不存在，
//    则会更新整体新增字段，虽然数据不会变，但是没有意义，不要这样修改